open Big_int
open Utils
open Sha256
open Merkle
open Syntax
open Crypto
open Parser

let eperms5 = [
[('X','U');('Y','X');('Z','W');('W','Y');('U','Z')];
[('X','U');('Y','X');('Z','W');('W','Z');('U','Y')];
[('X','U');('Y','X');('W','Y');('U','W')];
[('X','U');('Y','X');('U','Y')];
[('X','U');('Y','X');('Z','Y');('W','Z');('U','W')];
[('X','U');('Y','X');('Z','Y');('U','Z')];
[('X','U');('Z','W');('W','X');('U','Z')];
[('X','U');('Z','W');('W','Z');('U','X')];
[('X','U');('W','X');('U','W')];
[('X','U');('U','X')];
[('X','U');('Z','X');('W','Z');('U','W')];
[('X','U');('Z','X');('U','Z')];
[('X','U');('Y','Z');('Z','W');('W','X');('U','Y')];
[('X','U');('Y','Z');('Z','W');('W','Y');('U','X')];
[('X','U');('Y','Z');('Z','Y');('W','X');('U','W')];
[('X','U');('Y','Z');('Z','Y');('U','X')];
[('X','U');('Y','Z');('Z','X');('W','Y');('U','W')];
[('X','U');('Y','Z');('Z','X');('U','Y')];
[('X','U');('Y','W');('W','X');('U','Y')];
[('X','U');('Y','W');('W','Y');('U','X')];
[('X','U');('Y','W');('Z','Y');('W','X');('U','Z')];
[('X','U');('Y','W');('Z','Y');('W','Z');('U','X')];
[('X','U');('Y','W');('Z','X');('W','Y');('U','Z')];
[('X','U');('Y','W');('Z','X');('W','Z');('U','Y')];
[('X','W');('Y','X');('Z','U');('W','Y');('U','Z')];
[('X','W');('Y','X');('Z','U');('W','Z');('U','Y')];
[('X','W');('Y','X');('W','Y')];
[('X','W');('Y','X');('W','U');('U','Y')];
[('X','W');('Y','X');('Z','Y');('W','Z')];
[('X','W');('Y','X');('Z','Y');('W','U');('U','Z')];
[('X','W');('Z','U');('W','X');('U','Z')];
[('X','W');('Z','U');('W','Z');('U','X')];
[('X','W');('W','X')];
[('X','W');('W','U');('U','X')];
[('X','W');('Z','X');('W','Z')];
[('X','W');('Z','X');('W','U');('U','Z')];
[('X','W');('Y','Z');('Z','U');('W','X');('U','Y')];
[('X','W');('Y','Z');('Z','U');('W','Y');('U','X')];
[('X','W');('Y','Z');('Z','Y');('W','X')];
[('X','W');('Y','Z');('Z','Y');('W','U');('U','X')];
[('X','W');('Y','Z');('Z','X');('W','Y')];
[('X','W');('Y','Z');('Z','X');('W','U');('U','Y')];
[('X','W');('Y','U');('W','X');('U','Y')];
[('X','W');('Y','U');('W','Y');('U','X')];
[('X','W');('Y','U');('Z','Y');('W','X');('U','Z')];
[('X','W');('Y','U');('Z','Y');('W','Z');('U','X')];
[('X','W');('Y','U');('Z','X');('W','Y');('U','Z')];
[('X','W');('Y','U');('Z','X');('W','Z');('U','Y')];
[('X','Z');('Y','X');('Z','U');('W','Y');('U','W')];
[('X','Z');('Y','X');('Z','U');('U','Y')];
[('X','Z');('Y','X');('Z','W');('W','Y')];
[('X','Z');('Y','X');('Z','W');('W','U');('U','Y')];
[('X','Z');('Y','X');('Z','Y')];
[('X','Z');('Y','X');('Z','Y');('W','U');('U','W')];
[('X','Z');('Z','U');('W','X');('U','W')];
[('X','Z');('Z','U');('U','X')];
[('X','Z');('Z','W');('W','X')];
[('X','Z');('Z','W');('W','U');('U','X')];
[('X','Z');('Z','X')];
[('X','Z');('Z','X');('W','U');('U','W')];
[('X','Z');('Y','W');('Z','U');('W','X');('U','Y')];
[('X','Z');('Y','W');('Z','U');('W','Y');('U','X')];
[('X','Z');('Y','W');('Z','Y');('W','X')];
[('X','Z');('Y','W');('Z','Y');('W','U');('U','X')];
[('X','Z');('Y','W');('Z','X');('W','Y')];
[('X','Z');('Y','W');('Z','X');('W','U');('U','Y')];
[('X','Z');('Y','U');('Z','W');('W','X');('U','Y')];
[('X','Z');('Y','U');('Z','W');('W','Y');('U','X')];
[('X','Z');('Y','U');('Z','Y');('W','X');('U','W')];
[('X','Z');('Y','U');('Z','Y');('U','X')];
[('X','Z');('Y','U');('Z','X');('W','Y');('U','W')];
[('X','Z');('Y','U');('Z','X');('U','Y')];
[('X','Y');('Y','X');('Z','U');('W','Z');('U','W')];
[('X','Y');('Y','X');('Z','U');('U','Z')];
[('X','Y');('Y','X');('Z','W');('W','Z')];
[('X','Y');('Y','X');('Z','W');('W','U');('U','Z')];
[('X','Y');('Y','X')];
[('X','Y');('Y','X');('W','U');('U','W')];
[('X','Y');('Y','Z');('Z','U');('W','X');('U','W')];
[('X','Y');('Y','Z');('Z','U');('U','X')];
[('X','Y');('Y','Z');('Z','W');('W','X')];
[('X','Y');('Y','Z');('Z','W');('W','U');('U','X')];
[('X','Y');('Y','Z');('Z','X')];
[('X','Y');('Y','Z');('Z','X');('W','U');('U','W')];
[('X','Y');('Y','W');('Z','U');('W','X');('U','Z')];
[('X','Y');('Y','W');('Z','U');('W','Z');('U','X')];
[('X','Y');('Y','W');('W','X')];
[('X','Y');('Y','W');('W','U');('U','X')];
[('X','Y');('Y','W');('Z','X');('W','Z')];
[('X','Y');('Y','W');('Z','X');('W','U');('U','Z')];
[('X','Y');('Y','U');('Z','W');('W','X');('U','Z')];
[('X','Y');('Y','U');('Z','W');('W','Z');('U','X')];
[('X','Y');('Y','U');('W','X');('U','W')];
[('X','Y');('Y','U');('U','X')];
[('X','Y');('Y','U');('Z','X');('W','Z');('U','W')];
[('X','Y');('Y','U');('Z','X');('U','Z')];
[('Z','U');('W','Z');('U','W')];
[('Z','U');('U','Z')];
[('Z','W');('W','Z')];
[('Z','W');('W','U');('U','Z')];
[];
[('W','U');('U','W')];
[('Y','Z');('Z','U');('W','Y');('U','W')];
[('Y','Z');('Z','U');('U','Y')];
[('Y','Z');('Z','W');('W','Y')];
[('Y','Z');('Z','W');('W','U');('U','Y')];
[('Y','Z');('Z','Y')];
[('Y','Z');('Z','Y');('W','U');('U','W')];
[('Y','W');('Z','U');('W','Y');('U','Z')];
[('Y','W');('Z','U');('W','Z');('U','Y')];
[('Y','W');('W','Y')];
[('Y','W');('W','U');('U','Y')];
[('Y','W');('Z','Y');('W','Z')];
[('Y','W');('Z','Y');('W','U');('U','Z')];
[('Y','U');('Z','W');('W','Y');('U','Z')];
[('Y','U');('Z','W');('W','Z');('U','Y')];
[('Y','U');('W','Y');('U','W')];
[('Y','U');('U','Y')];
[('Y','U');('Z','Y');('W','Z');('U','W')];
[('Y','U');('Z','Y');('U','Z')]];;

let aperms5 = [
[('x','u');('y','x');('z','w');('w','y');('u','z')];
[('x','u');('y','x');('z','w');('w','z');('u','y')];
[('x','u');('y','x');('w','y');('u','w')];
[('x','u');('y','x');('u','y')];
[('x','u');('y','x');('z','y');('w','z');('u','w')];
[('x','u');('y','x');('z','y');('u','z')];
[('x','u');('z','w');('w','x');('u','z')];
[('x','u');('z','w');('w','z');('u','x')];
[('x','u');('w','x');('u','w')];
[('x','u');('u','x')];
[('x','u');('z','x');('w','z');('u','w')];
[('x','u');('z','x');('u','z')];
[('x','u');('y','z');('z','w');('w','x');('u','y')];
[('x','u');('y','z');('z','w');('w','y');('u','x')];
[('x','u');('y','z');('z','y');('w','x');('u','w')];
[('x','u');('y','z');('z','y');('u','x')];
[('x','u');('y','z');('z','x');('w','y');('u','w')];
[('x','u');('y','z');('z','x');('u','y')];
[('x','u');('y','w');('w','x');('u','y')];
[('x','u');('y','w');('w','y');('u','x')];
[('x','u');('y','w');('z','y');('w','x');('u','z')];
[('x','u');('y','w');('z','y');('w','z');('u','x')];
[('x','u');('y','w');('z','x');('w','y');('u','z')];
[('x','u');('y','w');('z','x');('w','z');('u','y')];
[('x','w');('y','x');('z','u');('w','y');('u','z')];
[('x','w');('y','x');('z','u');('w','z');('u','y')];
[('x','w');('y','x');('w','y')];
[('x','w');('y','x');('w','u');('u','y')];
[('x','w');('y','x');('z','y');('w','z')];
[('x','w');('y','x');('z','y');('w','u');('u','z')];
[('x','w');('z','u');('w','x');('u','z')];
[('x','w');('z','u');('w','z');('u','x')];
[('x','w');('w','x')];
[('x','w');('w','u');('u','x')];
[('x','w');('z','x');('w','z')];
[('x','w');('z','x');('w','u');('u','z')];
[('x','w');('y','z');('z','u');('w','x');('u','y')];
[('x','w');('y','z');('z','u');('w','y');('u','x')];
[('x','w');('y','z');('z','y');('w','x')];
[('x','w');('y','z');('z','y');('w','u');('u','x')];
[('x','w');('y','z');('z','x');('w','y')];
[('x','w');('y','z');('z','x');('w','u');('u','y')];
[('x','w');('y','u');('w','x');('u','y')];
[('x','w');('y','u');('w','y');('u','x')];
[('x','w');('y','u');('z','y');('w','x');('u','z')];
[('x','w');('y','u');('z','y');('w','z');('u','x')];
[('x','w');('y','u');('z','x');('w','y');('u','z')];
[('x','w');('y','u');('z','x');('w','z');('u','y')];
[('x','z');('y','x');('z','u');('w','y');('u','w')];
[('x','z');('y','x');('z','u');('u','y')];
[('x','z');('y','x');('z','w');('w','y')];
[('x','z');('y','x');('z','w');('w','u');('u','y')];
[('x','z');('y','x');('z','y')];
[('x','z');('y','x');('z','y');('w','u');('u','w')];
[('x','z');('z','u');('w','x');('u','w')];
[('x','z');('z','u');('u','x')];
[('x','z');('z','w');('w','x')];
[('x','z');('z','w');('w','u');('u','x')];
[('x','z');('z','x')];
[('x','z');('z','x');('w','u');('u','w')];
[('x','z');('y','w');('z','u');('w','x');('u','y')];
[('x','z');('y','w');('z','u');('w','y');('u','x')];
[('x','z');('y','w');('z','y');('w','x')];
[('x','z');('y','w');('z','y');('w','u');('u','x')];
[('x','z');('y','w');('z','x');('w','y')];
[('x','z');('y','w');('z','x');('w','u');('u','y')];
[('x','z');('y','u');('z','w');('w','x');('u','y')];
[('x','z');('y','u');('z','w');('w','y');('u','x')];
[('x','z');('y','u');('z','y');('w','x');('u','w')];
[('x','z');('y','u');('z','y');('u','x')];
[('x','z');('y','u');('z','x');('w','y');('u','w')];
[('x','z');('y','u');('z','x');('u','y')];
[('x','y');('y','x');('z','u');('w','z');('u','w')];
[('x','y');('y','x');('z','u');('u','z')];
[('x','y');('y','x');('z','w');('w','z')];
[('x','y');('y','x');('z','w');('w','u');('u','z')];
[('x','y');('y','x')];
[('x','y');('y','x');('w','u');('u','w')];
[('x','y');('y','z');('z','u');('w','x');('u','w')];
[('x','y');('y','z');('z','u');('u','x')];
[('x','y');('y','z');('z','w');('w','x')];
[('x','y');('y','z');('z','w');('w','u');('u','x')];
[('x','y');('y','z');('z','x')];
[('x','y');('y','z');('z','x');('w','u');('u','w')];
[('x','y');('y','w');('z','u');('w','x');('u','z')];
[('x','y');('y','w');('z','u');('w','z');('u','x')];
[('x','y');('y','w');('w','x')];
[('x','y');('y','w');('w','u');('u','x')];
[('x','y');('y','w');('z','x');('w','z')];
[('x','y');('y','w');('z','x');('w','u');('u','z')];
[('x','y');('y','u');('z','w');('w','x');('u','z')];
[('x','y');('y','u');('z','w');('w','z');('u','x')];
[('x','y');('y','u');('w','x');('u','w')];
[('x','y');('y','u');('u','x')];
[('x','y');('y','u');('z','x');('w','z');('u','w')];
[('x','y');('y','u');('z','x');('u','z')];
[('z','u');('w','z');('u','w')];
[('z','u');('u','z')];
[('z','w');('w','z')];
[('z','w');('w','u');('u','z')];
[];
[('w','u');('u','w')];
[('y','z');('z','u');('w','y');('u','w')];
[('y','z');('z','u');('u','y')];
[('y','z');('z','w');('w','y')];
[('y','z');('z','w');('w','u');('u','y')];
[('y','z');('z','y')];
[('y','z');('z','y');('w','u');('u','w')];
[('y','w');('z','u');('w','y');('u','z')];
[('y','w');('z','u');('w','z');('u','y')];
[('y','w');('w','y')];
[('y','w');('w','u');('u','y')];
[('y','w');('z','y');('w','z')];
[('y','w');('z','y');('w','u');('u','z')];
[('y','u');('z','w');('w','y');('u','z')];
[('y','u');('z','w');('w','z');('u','y')];
[('y','u');('w','y');('u','w')];
[('y','u');('u','y')];
[('y','u');('z','y');('w','z');('u','w')];
[('y','u');('z','y');('u','z')]];;

let eperms4 = [
[('X','W');('Y','X');('W','Y')];
[('X','W');('Y','X');('Z','Y');('W','Z')];
[('X','W');('W','X')];
[('X','W');('Z','X');('W','Z')];
[('X','W');('Y','Z');('Z','Y');('W','X')];
[('X','W');('Y','Z');('Z','X');('W','Y')];
[('X','Z');('Y','X');('Z','W');('W','Y')];
[('X','Z');('Y','X');('Z','Y')];
[('X','Z');('Z','W');('W','X')];
[('X','Z');('Z','X')];
[('X','Z');('Y','W');('Z','Y');('W','X')];
[('X','Z');('Y','W');('Z','X');('W','Y')];
[('X','Y');('Y','X');('Z','W');('W','Z')];
[('X','Y');('Y','X')];
[('X','Y');('Y','Z');('Z','W');('W','X')];
[('X','Y');('Y','Z');('Z','X')];
[('X','Y');('Y','W');('W','X')];
[('X','Y');('Y','W');('Z','X');('W','Z')];
[('Z','W');('W','Z')];
[];
[('Y','Z');('Z','W');('W','Y')];
[('Y','Z');('Z','Y')];
[('Y','W');('W','Y')];
[('Y','W');('Z','Y');('W','Z')]];;

let aperms4 = [
[('x','w');('y','x');('w','y')];
[('x','w');('y','x');('z','y');('w','z')];
[('x','w');('w','x')];
[('x','w');('z','x');('w','z')];
[('x','w');('y','z');('z','y');('w','x')];
[('x','w');('y','z');('z','x');('w','y')];
[('x','z');('y','x');('z','w');('w','y')];
[('x','z');('y','x');('z','y')];
[('x','z');('z','w');('w','x')];
[('x','z');('z','x')];
[('x','z');('y','w');('z','y');('w','x')];
[('x','z');('y','w');('z','x');('w','y')];
[('x','y');('y','x');('z','w');('w','z')];
[('x','y');('y','x')];
[('x','y');('y','z');('z','w');('w','x')];
[('x','y');('y','z');('z','x')];
[('x','y');('y','w');('w','x')];
[('x','y');('y','w');('z','x');('w','z')];
[('z','w');('w','z')];
[];
[('y','z');('z','w');('w','y')];
[('y','z');('z','y')];
[('y','w');('w','y')];
[('y','w');('z','y');('w','z')]];;

let eperms3 = [
[('X','Z');('Y','X');('Z','Y')];
[('X','Z');('Z','X')];
[('X','Y');('Y','X')];
[('X','Y');('Y','Z');('Z','X')];
[];
[('Y','Z');('Z','Y')]];;

let aperms3 = [
[('x','z');('y','x');('z','y')];
[('x','z');('z','x')];
[('x','y');('y','x')];
[('x','y');('y','z');('z','x')];
[];
[('y','z');('z','y')]];;

let sign = ref false;;
let publish = ref false;;
let verbose = ref 1;;
let evaluateconj = ref false;;
let currentfileh = ref "";;
let currentfileh58 = ref "";;
let currentfiletitle = ref "";;
let check_conjectures_for_subsumption = ref false;;
let othercreditnymh : (nym,int) Hashtbl.t = Hashtbl.create 10;;
let itemcount = ref 0;;
let volumeno = ref 0;;
let issueno = ref 0;;
let ensurecompletelysigned = ref false;;
let sgns = ref [];;
let latexc = ref stdout;;
let summary = ref false;;

let fakedepth = ref 0
let fakedepthh : (string,int) Hashtbl.t = Hashtbl.create 100
let fakelearn = ref false
let fakedist : (string * string,float) Hashtbl.t = Hashtbl.create 100

type refut =
  | Hyp of clause
  | Kn of int * clause * string 
  | Def of int * clause * string list * refut
  | Subst of int * clause * int * tm array * refut
  | Refl of int * clause * refut
  | Res of int * clause * lit * refut * refut
  | Para of int * clause * tm * tm * lit * refut * refut;;

let refutcomment : (refut,string) Hashtbl.t = Hashtbl.create 100;;

let print_refut_info r =
  let lineno = ref 1 in
  let h : (refut,int) Hashtbl.t = Hashtbl.create 100 in
  let rec print_refut_info_r r =
    if not (Hashtbl.mem h r) then
      begin
	let ln = !lineno in
	Hashtbl.add h r ln;
	incr lineno;
	begin
	  try
	    let c = Hashtbl.find refutcomment r in
	    Printf.printf "[%d] %s\n" ln c
	  with Not_found -> ()
	end;
	match r with
	| Hyp(cl) -> Printf.printf "%d. Hyp: %s\n" ln (clause_str cl)
	| Kn(_,cl,x) -> Printf.printf "%d. Known %s: %s\n" ln x (clause_str cl)
	| Def(_,cl,xl,r1) ->
	    print_refut_info_r r1;
	    Printf.printf "%d. Deltas" ln; List.iter (fun x -> Printf.printf " %s" x) xl;
	    Printf.printf ": %s by %d\n" (clause_str cl) (Hashtbl.find h r1)
	| Subst(_,cl,k,theta,r1) ->
	    print_refut_info_r r1;
	    Printf.printf "%d. Subst: %s by %d\n" ln (clause_str cl) (Hashtbl.find h r1)
	| Refl(_,cl,r1) ->
	    print_refut_info_r r1;
	    Printf.printf "%d. Refl: %s by %d\n" ln (clause_str cl) (Hashtbl.find h r1)
	| Res(_,cl,_,r1,r2) ->
	    print_refut_info_r r1;
	    print_refut_info_r r2;
	    Printf.printf "%d. Res: %s by %d,%d\n" ln (clause_str cl) (Hashtbl.find h r1) (Hashtbl.find h r2)
	| Para(_,cl,m1,m2,_,r1,r2) ->
	    print_refut_info_r r1;
	    print_refut_info_r r2;
	    Printf.printf "%d. Para (%s = %s): %s by %d,%d\n" ln (tm_str m1) (tm_str m2) (clause_str cl) (Hashtbl.find h r1) (Hashtbl.find h r2)
      end
  in
  print_refut_info_r r

let rem_dups l =
  let rec rem_dups_r l rl =
    match l with
    | a::r when List.mem a rl -> rem_dups_r r rl
    | a::r -> rem_dups_r r (a::rl)
    | [] -> rl
  in
  rem_dups_r l []

let depth : int ref = ref 0;;
let usableeqns : (string * tm * tm) list ref = ref [];;
let sos2 : refut list ref = ref [];;
let sos : refut list ref = ref [];;
let pending : (string * tm * tm * int) option ref = ref None;;
let rewritefailed = ref false;;
let rewritecount = ref 0;;
let countoptions = ref false;;
let abstracttimelimit = ref None;;
let abstracttimecount = ref 0;;

let advisorsocket = ref None;;
let advisorsocketfd = ref None;;
let advisorsocketin = ref None;;
let advisorsocketout = ref None;;

let open_advisor_socket () =
  match !advisorsocket with
  | None ->
      if !verbose > 1 then Printf.printf "No advisor\n"
  | Some(sock) ->
      let t1 = Unix.socket Unix.PF_INET Unix.SOCK_STREAM 0 in
      let ia = Unix.inet_addr_of_string "127.0.0.1" in
      Unix.connect t1 (Unix.ADDR_INET(ia, sock));
      advisorsocketfd := Some(t1);
      advisorsocketin := Some(Unix.in_channel_of_descr t1);
      advisorsocketout := Some(Unix.out_channel_of_descr t1)

let close_advisor_socket () =
  begin
    match !advisorsocketfd with
    | Some(t1) ->
	Unix.shutdown t1 Unix.SHUTDOWN_ALL;
	Unix.close t1
    | None -> ()
  end

exception AbstractTimeLimit;;
exception EmptyClause of refut;;

let hyprefs : (string option,bool) Hashtbl.t = Hashtbl.create 100;;

let axioms = [
  "397bbf43bf477cea90860dda24d94120dce41723f5d88e832c32d0b0a3b24e81";
  "2184e15b29d6fd2e313e4ea5ae0ad79a60ff01e38e803a60fc0b88db4b0bacc3";
  "46c19e3c61174e562bff1429b879c1a4b9666419aee687487a1ef8d505970841";
  "59fd3a14e001799be827ed797525af57526a585e7e0568a4caa0ff63d1e213a5";
  "de078b9508c9d429ff38315671454c16513bd2dc77c0b48f24958843d956ad26";
  "3771530a7b6b64867684ebec9159a93f496e67885cbc0aea4873f6c1398f6411";
  "49470c011b2801cfe3194ee7df6a6d51ea75b6b3600c0a246cf1456a19f999a8";
  "184e78e899b6e0fe0869a4926ea3d78cafbf38b30122c40bae4209c74b2d3524";
  "bc5d34b79ef11cf26e6bc0798ebe7a3c8b13f277c1a410ecf6c20db18516a8be";
  "fa6c343e72fba29154085f54946d09855c56518271243e197e0df37a97fb4da4";
  "b47852e8a285899bac1fd54ac22a00a796674f63095f2667d5279bf025155801";
  "8cfec45a332cd57fb0e238bac5cc0dbdbd17088d7c7b1ebc3b54bffa8f4f5b9c"
];;

let main7conjectures = [
  "678fb70a73634e5cd2c9d6843d31deb6feffc85fece61f0b054a39678e72d6dd";
  "f886df6cf6f9de5f303a4606f113dc319cdb80a44baf65a0837d96055b538766";
  "82b15b1015630406f549d3e1132be42a810b9018a02f5e1f367c1fbcc378e60c";
  "5b6d5525ce96b886df4b5b73fd092086bf65aa4796332da06c1ade16c89c9fbb";
  "d54500d91e3d64263ef639fdbcfa8a61d35b5468fc4e76326e26dcdb065f3ef1";
  "cbfb4363a0805a6d9b860d13f512d7c210257a87b8ba75451fba7d091ceebe7b";
  "6bb7c4d9f5ce4f337ea973fcd0e03beb452497e4ca5cba965c9d72bb083afcbd"
];;

let main5abbrevs = [
  (3,"b92287e489629dcd8586ce1dca89d36a30da0259351a2b738c915ed1287f1b0a");
  (2,"26b3335f83b6745a2cf93050b5e2c2e5e6df5ffcb49c042b709fcd9dae79bfd4");
  (2,"1f24505a8d5d29443b75542c864edb271c315991743813440806fa3c813a1124");
  (3,"ce732969701b096ac12147afcf266c35588c46a811d3d2ae9a0a94aa204e544c");
  (3,"077ee3019aec47d0a7a3e9323ddec0abc01e7bb1752ebe2d36b3d541888cba1b")
];;

let dualprim : (string,tm list -> tm) Hashtbl.t = Hashtbl.create 10;;
let dualabbrev : (string,tm list -> tm) Hashtbl.t = Hashtbl.create 10;;

Hashtbl.add dualprim "*" (fun s -> match s with [m;n] -> Prim("*",[n;m]) | _ -> raise Not_found);;
Hashtbl.add dualprim "\\" (fun s -> match s with [m;n] -> Prim("/",[n;m]) | _ -> raise Not_found);;
Hashtbl.add dualprim "/" (fun s -> match s with [m;n] -> Prim("\\",[n;m]) | _ -> raise Not_found);;
Hashtbl.add dualabbrev "ce732969701b096ac12147afcf266c35588c46a811d3d2ae9a0a94aa204e544c" (fun s -> match s with [m;n;k] -> Abbrev("077ee3019aec47d0a7a3e9323ddec0abc01e7bb1752ebe2d36b3d541888cba1b",[m;n;k]) | _ -> raise Not_found);; (*** L to R ***)
Hashtbl.add dualabbrev "077ee3019aec47d0a7a3e9323ddec0abc01e7bb1752ebe2d36b3d541888cba1b" (fun s -> match s with [m;n;k] -> Abbrev("ce732969701b096ac12147afcf266c35588c46a811d3d2ae9a0a94aa204e544c",[m;n;k]) | _ -> raise Not_found);; (*** R to L ***)

let confirm msg y n =
  let cnt = ref true in
  while !cnt do
    Printf.printf "%s " msg;
    flush stdout;
    let l = read_line () in
    if l = "" || l = "y" || l = "Y" then
      (y(); cnt := false)
    else if l = "n" || l = "N" then
      (n(); cnt := false)
    else
      Printf.printf "Please answer with y or n.\n";
  done

let ensure_dir_exists d f =
  try
    if not (Sys.is_directory d) then
      raise (Failure(d ^ " exists and is not a directory"))
  with Sys_error(_) ->
    f d;
    Unix.mkdir d 0o775;;

let read_signatures_then_line c collectsigs =
  let ll = ref "" in
  try
    while true do
      let l = input_line c in
      if String.length l > 4 && String.sub l 0 4 = "SIG:" then
	begin
	  if collectsigs then
	    let sgs = String.sub l 4 (String.length l - 4) in
	    let sg = sgn_from_aimsgn sgs in
	    sgns := (sg,sgs)::!sgns
	end
      else
	(ll := l; raise Exit)
    done;
    !ll
  with Exit ->
    !ll;;
      
let rand256 () =
  let dr = open_in_bin "/dev/random" in
  let k = ref zero_big_int in
  for i = 1 to 32 do
    let r = input_byte dr in
    k := or_big_int (shift_left_big_int !k 8) (big_int_of_int r)
  done;
  close_in dr;
  !k;;

let editors : (int * nym) list ref = ref [];;
let unlistededitors : (int * nym) list ref = ref [];;
let quorum : int ref = ref 4;;
let allknowns_merkle_root = ref "";;
let allknowns_merkl : merkl option ref = ref None;;
let allknowns_merkl_lookups : (string,unit) Hashtbl.t = Hashtbl.create 10;;
let allconjs_merkle_root = ref "";;
let allconjs_merkl : merkl option ref = ref None;;
let allconjs_merkl_lookups : (string,unit) Hashtbl.t = Hashtbl.create 10;;
let allnonthms_merkle_root = ref "";;
let allnonthms_merkl : merkl option ref = ref None;;
let allnonthms_merkl_lookups : (string,unit) Hashtbl.t = Hashtbl.create 10;;
let allloops_merkle_root = ref "";;
let allloops_merkl : merkl option ref = ref None;;
let allloops_merkl_lookups : (string,unit) Hashtbl.t = Hashtbl.create 10;;
let allabbrevs_merkle_root = ref "";;
let allabbrevs_merkl : merkl option ref = ref None;;
let allabbrevs_merkl_lookups : (string,unit) Hashtbl.t = Hashtbl.create 10;;
let knownclauses : (string,string) Hashtbl.t = Hashtbl.create 10;;
let abbrevroot : (string,string) Hashtbl.t = Hashtbl.create 10;;
let abbrevarity : (string,int) Hashtbl.t = Hashtbl.create 10;;
let abbrevdef : (string,tm) Hashtbl.t = Hashtbl.create 10;;

let title_split x =
  let xr = ref x in
  let r = ref "" in
  while not (!xr = "") do
    if String.length !xr < 10 then
      if !r = "" then
	(r := !xr; xr := "")
      else
	(r := !r ^ " " ^ !xr; xr := "")
    else if !r = "" then
      (r := String.sub !xr 0 7; xr := String.sub !xr 7 (String.length !xr - 7))
    else
      (r := !r ^ " " ^ String.sub !xr 0 7; xr := String.sub !xr 7 (String.length !xr - 7))
  done;
  !r

let known_lookup k f g =
  try
    if not (Hashtbl.mem allknowns_merkl_lookups k) then Hashtbl.add allknowns_merkl_lookups k ();
    f (merkle_lookup !allknowns_merkl k)
  with
  | Not_found -> g()
  | MerkleH(x) ->
      Printf.printf "Hash %s in merkle tree for knowns must be expanded.\n" x;
      exit 1
      
let conj_lookup k f g =
  try
    if not (Hashtbl.mem allconjs_merkl_lookups k) then Hashtbl.add allconjs_merkl_lookups k ();
    f (merkle_lookup !allconjs_merkl k)
  with
  | Not_found -> g()
  | MerkleH(x) ->
      Printf.printf "Hash %s in merkle tree for conjectures must be expanded.\n" x;
      exit 1

let nonthm_lookup k f g =
  try
    if not (Hashtbl.mem allnonthms_merkl_lookups k) then Hashtbl.add allnonthms_merkl_lookups k ();
    f (merkle_lookup !allnonthms_merkl k)
  with
  | Not_found -> g()
  | MerkleH(x) ->
      Printf.printf "Hash %s in merkle tree for nonthms must be expanded.\n" x;
      exit 1

let loop_lookup k f g =
  try
    if not (Hashtbl.mem allloops_merkl_lookups k) then Hashtbl.add allloops_merkl_lookups k ();
    f (merkle_lookup !allloops_merkl k)
  with
  | Not_found -> g()
  | MerkleH(x) ->
      Printf.printf "Hash %s in merkle tree for loops must be expanded.\n" x;
      exit 1

let abbrev_lookup k f g =
  try
    if not (Hashtbl.mem allabbrevs_merkl_lookups k) then Hashtbl.add allabbrevs_merkl_lookups k ();
    f (merkle_lookup !allabbrevs_merkl k)
  with
  | Not_found -> g()
  | MerkleH(x) ->
      Printf.printf "Hash %s in merkle tree for abbrevs must be expanded.\n" x;
      exit 1

let clear_declarations () =
  Hashtbl.clear knownclauses;
  Hashtbl.clear abbrevroot;
  Hashtbl.clear abbrevarity;
  Hashtbl.clear abbrevdef;;

let state_root () =
  let h = ref (sha256 (Printf.sprintf "volume:%d:issueno:%d:quorum:%d" !volumeno !issueno !quorum)) in
  List.iter
    (fun (r,(e1,e2,e3)) -> h := sha256 (Printf.sprintf "%s:editor:%d:%s:%s:%s" !h r e1 e2 e3))
    !editors;
  h := sha256 (Printf.sprintf "%s:knownroot:%s" !h (ostr (merkle_root !allknowns_merkl)));
  h := sha256 (Printf.sprintf "%s:abbrevroot:%s" !h (ostr (merkle_root !allabbrevs_merkl)));
  h := sha256 (Printf.sprintf "%s:conjroot:%s" !h (ostr (merkle_root !allconjs_merkl)));
  h := sha256 (Printf.sprintf "%s:nonthmroot:%s" !h (ostr (merkle_root !allnonthms_merkl)));
  h := sha256 (Printf.sprintf "%s:looproot:%s" !h (ostr (merkle_root !allloops_merkl)));
  !h;;

(*** hardcoded genesis state ***)
let genesis_state () =
  editors := [(4,("CXSbZP8nCbob49P892dvsj5A1Dsmrg7AvKn6zYTkABum","CcEFyW5EuzeERJkTVVTSdUY31tLDzApiHuD9kkrK7XYv","TaULp"))];
  volumeno := 1;
  issueno := 1;
  quorum := 4;;
    
type pfctx = (string * tm) list * (string option * clause) list;;

type pfstatetype =
  | PfStateGoal of pfctx * lit list
  | PfStateSep of int * bool

let proving : (string * string * int * pfstatetype list) option ref = ref None;;
    
let eqproving : (string * string * int * pfctx * string option * tm * tm * lit list * pfstatetype list) option ref = ref None;;

let fakefvh : (string,int) Hashtbl.t = Hashtbl.create 1;;
let fakefv : ((string,int) Hashtbl.t) * int ref = (fakefvh,ref (-1));;

let global_loops : (string,loopimpl) Hashtbl.t = Hashtbl.create 5;;
let global_loop_hash : (string,string) Hashtbl.t = Hashtbl.create 5;;
let global_loop_htmlnum : (string,int) Hashtbl.t = Hashtbl.create 5;;
    
let global_latex_ref : (string,string) Hashtbl.t = Hashtbl.create 100;;
let local_latex_ref : (string,string) Hashtbl.t = Hashtbl.create 100;;
let local_latex_ref_counter = ref 0;;
let global_html_ref : (string,string) Hashtbl.t = Hashtbl.create 100;;
let local_html_ref : (string,string) Hashtbl.t = Hashtbl.create 100;;
let local_html_ref_counter = ref 0;;
let htmlthmcount = ref 1;;

let latex_ref x =
  try
    Hashtbl.find local_latex_ref x
  with Not_found ->
    try
      Hashtbl.find global_latex_ref x
    with Not_found ->
      Printf.sprintf "(\\ref{%s})" x;;

let html_ref x =
  try
    Hashtbl.find local_html_ref x
  with Not_found ->
    try
      Hashtbl.find global_html_ref x
    with Not_found ->
      Printf.sprintf "(%s)" x;;

let html_outer_ref fvh x =
  if Hashtbl.mem fvh x then
    x
  else
    let r = Hashtbl.find abbrevroot x in
    Printf.sprintf "<a href='ref.php?h=%s'>%s</a>" r x
    
let rec interp_aim_tm_r m fv nctx =
  match m with
  | Na("e") -> Prim("e",[])
  | Na(x) ->
      begin
	try
	  List.assoc x nctx
	with Not_found ->
	  let (fvh,fvc) = fv in
	  try
	    let v = Hashtbl.find fvh x in
	    Var(v)
	  with Not_found ->
	    if !fvc >= 0 then
	      let v = !fvc in
	      incr fvc;
	      Hashtbl.add fvh x v;
	      Var(v)
	    else
	      raise (Failure("Unknown name " ^ x))
      end
  | Info(InfNam("*"),m,n) -> Prim("*",[interp_aim_tm_r m fv nctx;interp_aim_tm_r n fv nctx])
  | Info(InfNam("\\"),m,n) -> Prim("\\",[interp_aim_tm_r m fv nctx;interp_aim_tm_r n fv nctx])
  | Info(InfNam("/"),m,n) -> Prim("/",[interp_aim_tm_r m fv nctx;interp_aim_tm_r n fv nctx])
  | Implop(Na(h),Tuple(m1,m2,mr)) ->
      begin
	try
	  let hr = Hashtbl.find abbrevroot h in
	  try
	    let ha = Hashtbl.find abbrevarity hr in
	    let ml = m1::m2::mr in
	    if not (List.length ml = ha) then
	      raise (Failure(h ^ " expected to have arity " ^ (string_of_int ha) ^ " but used with arity " ^ (string_of_int (List.length ml))))
	    else
	      Abbrev(hr,interp_aim_spine_r ml fv nctx)
	  with Not_found ->
	    raise (Failure("Unknown arity for " ^ h))
	with Not_found ->
	  raise (Failure("Unknown abbrev " ^ h))
      end
  | Implop(Na(h),m1) ->
      begin
	try
	  let hr = Hashtbl.find abbrevroot h in
	  try
	    let ha = Hashtbl.find abbrevarity hr in
	    let ml = [m1] in
	    if not (List.length ml = ha) then
	      raise (Failure(h ^ " expected to have arity " ^ (string_of_int ha) ^ " but used with arity " ^ (string_of_int (List.length ml))))
	    else
	      Abbrev(hr,interp_aim_spine_r ml fv nctx)
	  with Not_found ->
	    raise (Failure("Unknown arity for " ^ h))
	with Not_found ->
	  raise (Failure("Unknown abbrev " ^ h))
      end
  | _ ->
      output_atree stdout m;
      raise (Failure("cannot interpret as aim term"))
and interp_aim_spine_r s fv nctx =
  match s with
  | m::r -> interp_aim_tm_r m fv nctx::interp_aim_spine_r r fv nctx
  | [] -> []
  
let interp_aim_lit_r l fv nctx =
  match l with
  | Info(InfNam("="),m,n) -> Eq(interp_aim_tm_r m fv nctx,interp_aim_tm_r n fv nctx)
  | Info(InfNam("!="),m,n) -> NEq(interp_aim_tm_r m fv nctx,interp_aim_tm_r n fv nctx)
  | _ ->
      output_atree stdout l;
      raise (Failure "cannot interp as aim lit")

let rec interp_aim_clause_r c fv nctx =
  match c with
  | Info(InfNam("->"),nc1,c2) ->
      interp_aim_clause_neg_r nc1 fv nctx @ interp_aim_clause_r c2 fv nctx
  | Info(InfNam("|"),c1,c2) ->
      interp_aim_clause_r c1 fv nctx @ interp_aim_clause_r c2 fv nctx
  | Info(InfNam("&"),_,_) -> raise (Failure "not a single clause; needs to be split")
  | _ -> [interp_aim_lit_r c fv nctx]
and interp_aim_clause_neg_r c fv nctx =
  match c with
  | Info(InfNam("->"),c1,nc2) ->
      interp_aim_clause_r c1 fv nctx @ interp_aim_clause_neg_r nc2 fv nctx
  | Info(InfNam("&"),nc1,nc2) ->
      interp_aim_clause_neg_r nc1 fv nctx @ interp_aim_clause_neg_r nc2 fv nctx
  | Info(InfNam("|"),_,_) -> raise (Failure "not a single clause; needs to be split")
  | _ -> [lit_negate (interp_aim_lit_r c fv nctx)]

let interp_aim_clause c nctx =
  let fvh = Hashtbl.create 10 in
  let fvc = ref 0 in
  interp_aim_clause_r c (fvh,fvc) nctx

let ostring_sexpr s =
  match s with
  | Some(x) -> Printf.sprintf "\"%s\"" x
  | None -> "NIL"

let root_aname r =
  Printf.sprintf "<a name='r:%s'/e>" r
    
let o_aname s =
  match s with
  | Some(x) -> Printf.sprintf "<a name='%s'/>" x
  | None -> ""

let o_href s y =
  match s with
  | Some(x) -> Printf.sprintf "<a href='#%s'>%s</a>" x y
  | None -> ""

exception UnifFail

let rec occurs_check_p i theta m =
  match m with
  | Var(j) ->
      begin
	match theta.(j) with
	| Some(n) -> occurs_check_p i theta n
	| None -> i = j
      end
  | Prim(_,sp) -> occurs_check_sp_p i theta sp
  | Abbrev(_,sp) -> occurs_check_sp_p i theta sp
  | _ -> false
and occurs_check_sp_p i theta ml =
  match ml with
  | m::mr -> occurs_check_p i theta m || occurs_check_sp_p i theta mr
  | [] -> false

let rec unif_dpairs theta dl : unit =
  if !verbose > 5 then
    begin
      Printf.printf "unif_dpairs dl %d\n" (List.length dl);
      List.iter (fun (m,n) -> Printf.printf ". %s =? %s\n" (tm_str m) (tm_str n)) dl;
      flush stdout;
    end;
  match dl with
  | [] -> ()
  | (m,n)::dr when m = n -> unif_dpairs theta dr
  | (Var(i),m)::dr ->
      begin
	match theta.(i) with
	| Some(n) ->
	    unif_dpairs theta ((n,m)::dr)
	| None ->
	    if !verbose > 5 then (Printf.printf "Occurs check %d in %s test\n" i (tm_str m); flush stdout); 
	    if occurs_check_p i theta m then raise UnifFail;
	    if !verbose > 5 then (Printf.printf "Setting %d to %s\n" i (tm_str m); flush stdout); 
	    theta.(i) <- Some(m);
	    unif_dpairs theta dr
      end
  | (m,Var(i))::dr ->
      begin
	match theta.(i) with
	| Some(n) ->
	    unif_dpairs theta ((m,n)::dr)
	| None ->
	    if !verbose > 5 then (Printf.printf "Occurs check %d in %s test\n" i (tm_str m); flush stdout); 
	    if occurs_check_p i theta m then raise UnifFail;
	    if !verbose > 5 then (Printf.printf "Setting %d to %s\n" i (tm_str m); flush stdout); 
	    theta.(i) <- Some(m);
	    unif_dpairs theta dr
      end
  | (Prim(h1,args1),Prim(h2,args2))::dr when h1 = h2 && List.length args1 = List.length args2 ->
      unif_dpairs theta ((List.map2 (fun m n -> (m,n)) args1 args2) @ dr)
  | (Abbrev(h1,args1),Abbrev(h2,args2))::dr when h1 = h2 && List.length args1 = List.length args2 ->
      unif_dpairs theta ((List.map2 (fun m n -> (m,n)) args1 args2) @ dr)
  | (_,_)::dr -> raise UnifFail

let rec match_dpairs theta dl deltas =
  match dl with
  | [] -> true
  | (Var(i),m)::dr ->
      begin
	match theta.(i) with
	| Some(n) ->
	    if m = n then
	      match_dpairs theta dr deltas
	    else
	      false
	| None ->
	    theta.(i) <- Some(m);
	    match_dpairs theta dr deltas
      end
  | (Skol(x),Skol(y))::dr ->
      if x = y then
	match_dpairs theta dr deltas
      else
	false
  | (Prim(x,sl),Prim(y,tl))::dr ->
      if x = y then
	match_dpairs theta ((List.map2 (fun m n -> (m,n)) sl tl) @ dr) deltas
      else
	false
  | (Abbrev(x,sl),n)::dr when List.mem_assoc x deltas ->
      begin
	try
	  let (arity,m) = List.assoc x deltas in
	  let theta2 = Array.make arity (Skol("fake")) in
	  if arity = List.length sl then
	    begin
	      for i = 0 to arity-1 do
		theta2.(i) <- List.nth sl i
	      done;
	      match_dpairs theta ((tm_subst theta2 m,n)::dr) deltas
	    end
	  else
	    false
	with Not_found ->
	  false
      end
  | (m,Abbrev(x,sl))::dr when List.mem_assoc x deltas ->
      begin
	try
	  let (arity,n) = List.assoc x deltas in
	  let theta2 = Array.make arity (Skol("fake")) in
	  if arity = List.length sl then
	    begin
	      for i = 0 to arity-1 do
		theta2.(i) <- List.nth sl i
	      done;
	      match_dpairs theta ((m,tm_subst theta2 n)::dr) deltas
	    end
	  else
	    false
	with Not_found ->
	  false
      end
  | (Abbrev(x,sl),Abbrev(y,tl))::dr ->
      if x = y then
	match_dpairs theta ((List.map2 (fun m n -> (m,n)) sl tl) @ dr) deltas
      else
	false
  | (_,_)::dr -> false

let match_lit n theta l1 l2 deltas =
  match l1,l2 with
  | Eq(m1,n1),Eq(m2,n2) -> match_dpairs theta [(m1,m2);(n1,n2)] deltas
  | NEq(m1,n1),NEq(m2,n2) -> match_dpairs theta [(m1,m2);(n1,n2)] deltas
  | _,_ -> false

let delta_eq l r deltas =
  let theta : tm option array = Array.make 0 None in (*** fake value to call match_dpairs with ***)
  match_dpairs theta [(l,r)] deltas

(*** dl: dpairs, ground; all vars are in lhs and rhs ***)
let rec ematch1_dpairs n theta lhs rhs dl deltas =
  match dl with
  | [] -> true
  | (m1,m2)::dr ->
      let savetheta : tm option array = Array.make n None in
      for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
      begin
	try
	  if not (match_dpairs theta [(lhs,m1);(rhs,m2)] deltas) then raise Exit;
	  if not (ematch1_dpairs n theta lhs rhs dr deltas) then raise Exit;
	  true
	with Exit ->
	  try
	    for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;	  
	    if not (match_dpairs theta [(lhs,m2);(rhs,m1)] deltas) then raise Exit;
	    if not (ematch1_dpairs n theta lhs rhs dr deltas) then raise Exit;
	    true
	  with Exit ->
	    for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;	  
	    ematch1_dpairs_2 n theta lhs rhs dl deltas
      end
and ematch1_dpairs_2 n theta lhs rhs dl deltas =
  match dl with
  | [] -> true
  | (Skol(x),Skol(y))::dr ->
      if x = y then
	ematch1_dpairs n theta lhs rhs dr deltas
      else
	false
  | (Prim(x,sl),Prim(y,tl))::dr ->
      if x = y then
	ematch1_dpairs n theta lhs rhs ((List.map2 (fun m n -> (m,n)) sl tl) @ dr) deltas
      else
	false
  | (Abbrev(x,sl),Abbrev(y,tl))::dr ->
      if x = y then
	ematch1_dpairs n theta lhs rhs ((List.map2 (fun m n -> (m,n)) sl tl) @ dr) deltas
      else
	false
  | (_,_)::dr -> false

let ematch1_lit n theta lhs rhs l1 l2 deltas =
  match l1,l2 with
  | Eq(m1,n1),Eq(m2,n2) -> ematch1_dpairs n theta lhs rhs [(m1,m2);(n1,n2)] deltas
  | NEq(m1,n1),NEq(m2,n2) -> ematch1_dpairs n theta lhs rhs [(m1,m2);(n1,n2)] deltas
  | _,_ -> false

let sym_lit l =
  match l with
  | Eq(m,n) -> Eq(n,m)
  | NEq(m,n) -> NEq(n,m)

let obvious_by_res n maincl gunits deltas =
  let theta : tm option array = Array.make n None in
  let rec obvious_by_res_r maincl gunits =
    match maincl with
    | [] -> true
    | l::maincr -> obvious_by_res_r_2 (lit_negate l) maincr gunits gunits
  and obvious_by_res_r_2 nl maincr gunits allgunits =
    match gunits with
    | gl::gunitr ->
	begin
	  let savetheta : tm option array = Array.make n None in
	  for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
	  try
	    if not (match_lit n theta nl gl deltas) then raise Exit;
	    if not (obvious_by_res_r maincr allgunits) then raise Exit;
	    true
	  with Exit ->
	    for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;
	    try
	      let gl2 = sym_lit gl in
	      if not (match_lit n theta nl gl2 deltas) then raise Exit;
	      if not (obvious_by_res_r maincr allgunits) then raise Exit;
	      true
	    with
	    | Exit ->
		for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;
		obvious_by_res_r_2 nl maincr gunitr allgunits
	end
    | [] -> false
  in
  obvious_by_res_r maincl gunits

let obvious_by_para_1 n maincl gunits deltas =
  let theta : tm option array = Array.make n None in
  let rec obvious_by_para_1_r maincl gunits =
    match maincl with
    | [] -> true
    | (Eq(l,r) as li)::maincr ->
	(obvious_by_para_1_r_3 l r maincr gunits || obvious_by_para_1_r_2 (lit_negate li) maincr gunits gunits)
    | l::maincr -> obvious_by_para_1_r_2 (lit_negate l) maincr gunits gunits
  and obvious_by_para_1_r_2 nl maincr gunits allgunits =
    match gunits with
    | gl::gunitr ->
	begin
	  let savetheta : tm option array = Array.make n None in
	  for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
	  try
	    if not (match_lit n theta nl gl deltas) then raise Exit;
	    if not (obvious_by_para_1_r maincr allgunits) then raise Exit;
	    true
	  with Exit ->
	    for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;
	    obvious_by_para_1_r_2 nl maincr gunitr allgunits
	end
    | [] -> false
  and obvious_by_para_1_r_3 lhs rhs maincl gunits =
    match maincl with
    | [] -> (*** all lits except the lhs = rhs eqn have been resolved; now use eqn to paramod either a unit diseqn to be negrefl or two units to be compl ***)
	(obvious_by_para_1_r_5 lhs rhs gunits || obvious_by_para_1_r_6 lhs rhs gunits gunits)
    | l::maincr -> obvious_by_para_1_r_4 lhs rhs (lit_negate l) maincr gunits gunits
  and obvious_by_para_1_r_4 lhs rhs nl maincr gunits allgunits =
    match gunits with
    | gl::gunitr ->
	begin
	  let savetheta : tm option array = Array.make n None in
	  for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
	  try
	    if not (match_lit n theta nl gl deltas) then raise Exit;
	    if not (obvious_by_para_1_r_3 lhs rhs maincr allgunits) then raise Exit;
	    true
	  with Exit ->
	    for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;
	    obvious_by_para_1_r_4 lhs rhs nl maincr gunitr allgunits
	end
    | [] -> false
  and obvious_by_para_1_r_5 lhs rhs gunits =
    match gunits with
    | NEq(lhs2,rhs2)::gunitr ->
	begin
	  let savetheta : tm option array = Array.make n None in
	  for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
	  try
	    if not (ematch1_dpairs n theta lhs rhs [(lhs2,rhs2)] deltas) then raise Exit;
	    true
	  with Exit ->
	    try
	      if not (ematch1_dpairs n theta rhs lhs [(lhs2,rhs2)] deltas) then raise Exit;
	      true
	    with Exit ->
	      for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;
	      obvious_by_para_1_r_5 lhs rhs gunitr
	end
    | _::gunitr -> obvious_by_para_1_r_5 lhs rhs gunitr
    | [] -> false
  and obvious_by_para_1_r_6 lhs rhs gunits allgunits =
    match gunits with
    | gl::gunitr ->
	begin
	  let savetheta : tm option array = Array.make n None in
	  for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
	  try
	    if obvious_by_para_1_r_7 lhs rhs (lit_negate gl) allgunits then
	      true
	    else
	      raise Exit
	  with Exit ->
	    for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;
	    obvious_by_para_1_r_6 lhs rhs gunitr allgunits
	end
    | [] -> false
  and obvious_by_para_1_r_7 lhs rhs ngl gunits =
    match gunits with
    | gl::gunitr ->
	begin
	  let savetheta : tm option array = Array.make n None in
	  for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
	  try
	    if not (ematch1_lit n theta lhs rhs ngl gl deltas) then raise Exit;
	    true
	  with Exit ->
	    try
	      for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
	      if not (ematch1_lit n theta rhs lhs ngl gl deltas) then raise Exit;
	      true
	    with Exit ->
	      let gl2 = sym_lit gl in
	      try
		for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
		if not (ematch1_lit n theta lhs rhs ngl gl2 deltas) then raise Exit;
		true
	      with Exit ->
		try
		  for i = 0 to (n-1) do savetheta.(i) <- theta.(i) done;
		  if not (ematch1_lit n theta rhs lhs ngl gl2 deltas) then raise Exit;
		  true
		with Exit ->
		  for i = 0 to (n-1) do theta.(i) <- savetheta.(i) done;
		  obvious_by_para_1_r_7 lhs rhs ngl gunitr
	end
    | [] -> false
  in
  obvious_by_para_1_r maincl gunits

let obvious_by_para_2 n maincl guniteqns deltas =
  false

let obvious_by_para_3 lhs rhs gunits deltas =
  let theta : tm option array = Array.make 0 None in (*** fake value to call ematch1 with ***)
  let rec obvious_by_para_3_r_5 gunits =
    match gunits with
    | NEq(lhs2,rhs2)::gunitr ->
	if ematch1_dpairs 0 theta lhs rhs [(lhs2,rhs2)] deltas then
	  true
	else if ematch1_dpairs 0 theta rhs lhs [(lhs2,rhs2)] deltas then
	  true
	else
	  obvious_by_para_3_r_5 gunitr
    | _::gunitr -> obvious_by_para_3_r_5 gunitr
    | [] -> false
  and obvious_by_para_3_r_6 gunits allgunits =
    match gunits with
    | gl::gunitr ->
	if obvious_by_para_3_r_7 (lit_negate gl) allgunits then
	  true
	else
	  obvious_by_para_3_r_6 gunitr allgunits
    | [] -> false
  and obvious_by_para_3_r_7 ngl gunits =
    match gunits with
    | gl::gunitr ->
	if ematch1_lit 0 theta lhs rhs ngl gl deltas then
	  true
	else if ematch1_lit 0 theta rhs lhs ngl gl deltas then
	  true
	else
	  obvious_by_para_3_r_7 ngl gunitr
    | [] -> false
  in
  obvious_by_para_3_r_5 gunits || obvious_by_para_3_r_6 gunits gunits

let ensureobvious pctx nll thn obyl =
  let (nctx,hyps) = pctx in
  let refclauses = ref [] in
  let refdeltas = ref [] in
  if thn then
    begin
      match hyps with
      | (_,cl)::hypr -> refclauses := cl::!refclauses
      | [] ->
	  Printf.printf "justification failed at line %d char %d\n" !lineno !charno;
	  raise (Failure "nothing to link")
    end;
  begin
    match obyl with
    | None -> if !fakelearn then incr fakedepth;
    | Some(byl) ->
	if !fakelearn then
	  begin
	    List.iter
	      (fun b ->
		try
		  fakedepth := !fakedepth + Hashtbl.find fakedepthh b
		with Not_found ->
		  incr fakedepth)
	      byl
	  end;
	List.iter
	  (fun x ->
	    try
	      let cl = List.assoc (Some(x)) hyps in
	      if !sexpr then Hashtbl.replace hyprefs (Some(x)) true;
	      refclauses := cl::!refclauses
	    with Not_found ->
	      try
		let cl = clause_with_root (Hashtbl.find knownclauses x) in
		if !sexpr then Printf.printf "(KNOWNDEP \"%s\")\n" x;
		refclauses := cl::!refclauses
	      with Not_found ->
		try
		  let r = Hashtbl.find abbrevroot x in
		  if !sexpr then Printf.printf "(DELTADEP \"%s\")\n" x;
		  try
		    let arity = Hashtbl.find abbrevarity r in
		    let m = Hashtbl.find abbrevdef r in
		    refdeltas := (r,(arity,m))::!refdeltas
		  with Not_found ->
		    Printf.printf "the definition of %s is opaque here and cannot be used in a justification at line %d char %d\n" x !lineno !charno;
		    raise (Failure "attempt to expand opaque defn")
		with Not_found ->
		  Printf.printf "cannot find reference %s at line %d char %d\n" x !lineno !charno;
		  raise (Failure "unknown ref"))
	  byl
  end;
  List.iter (fun nl -> refclauses := [nl]::!refclauses) nll;
  if !verbose > 9 then
    begin
      Printf.printf "here are all ref clauses:\n";
      List.iter
	(fun cl ->
	  Printf.printf ". %s\n" (clause_str cl))
	!refclauses;
    end;
  if List.mem [] !refclauses then (*** empty clause known ***)
    ()
  else if (List.exists (fun cl1 -> match cl1 with [NEq(l,r)] when delta_eq l r !refdeltas -> true | _ -> false) !refclauses) then (*** negated reflexivity unit ***)
    ()
  else if (List.exists (fun cl1 -> match cl1 with [l1] -> List.mem [lit_negate l1] !refclauses | _ -> false) !refclauses) then (*** unit conflict ***)
    ()
  else
    let grounduniteqns = ref [] in
    let allgroundunits = ref [] in
    let mainclauses = ref [] in
    List.iter
      (fun cl ->
	let n = clause_var_upperbd cl in
	if n = 0 then (*** ground ***)
	  begin
	    match cl with
	    | [Eq(l,r) as li] ->
		grounduniteqns := (l,r)::!grounduniteqns;
		grounduniteqns := (r,l)::!grounduniteqns;
		allgroundunits := li::!allgroundunits;
		allgroundunits := Eq(r,l)::!allgroundunits;
	    | [li] -> allgroundunits := li::!allgroundunits
	    | _ -> mainclauses := (0,cl)::!mainclauses
	  end
	else
	  mainclauses := (n,cl)::!mainclauses)
      !refclauses;
    match !mainclauses with
    | (_::_::_) ->
	Printf.printf "justification failed at line %d char %d, too many open/nonunit clause refs (should be 0 or 1)\n" !lineno !charno;
	raise (Failure "failed justification")	
    | [(n,maincl)] ->
	begin
	  if obvious_by_res n maincl !allgroundunits !refdeltas then
	    ()
	  else if obvious_by_para_1 n maincl !allgroundunits !refdeltas then
	    ()
	  else if obvious_by_para_2 n maincl !grounduniteqns !refdeltas then
	    ()
	  else
	    begin
	      Printf.printf "justification failed at line %d char %d, could not use main clause to complete the inference\n" !lineno !charno;
	      raise (Failure "failed justification")	
	    end
	end
    | [] -> (*** no main clause and no unit conflict; last hope is delta or unit eqn para into another ground ***)
	if List.exists
	    (fun (l,r) -> obvious_by_para_3 l r !allgroundunits !refdeltas)
	    !grounduniteqns
	then
	  ()
	else
	  begin
	    Printf.printf "justification failed at line %d char %d, all references are unit and ground, but no conflict or rewriting found to complete the inference\n" !lineno !charno;
	    if !verbose > 5 then
	      begin
		Printf.printf "here are all ref clauses:\n";
		List.iter
		  (fun cl ->
		    Printf.printf ". %s\n" (clause_str cl))
		  !refclauses;
	      end;
	    raise (Failure "failed justification")
	  end

let clause_subsumes_p cl1 cl2 =
  let n1 = clause_var_upperbd cl1 in
  let nll2 = negate_clause cl2 in
  obvious_by_res n1 cl1 nll2 []
	    
let printf_latex_by byl =
  match byl with
  | [] -> ()
  | [by1] ->
      Printf.fprintf !latexc " by ";
      Printf.fprintf !latexc "%s" (latex_ref by1)
  | (by1::by2::byr) ->
      Printf.fprintf !latexc " by ";
      Printf.fprintf !latexc "%s" (latex_ref by1);
      let rec printf_latex_byr by2 byr =
	match byr with
	| [] -> Printf.fprintf !latexc " and %s" (latex_ref by2)
	| by3::byrr ->
	    Printf.fprintf !latexc ", %s" (latex_ref by2);
	    printf_latex_byr by3 byrr
      in
      printf_latex_byr by2 byr

let printf_html_by c byl =
  match byl with
  | [] -> ()
  | [by1] ->
      Printf.fprintf c " by ";
      Printf.fprintf c "%s" (html_ref by1)
  | (by1::by2::byr) ->
      Printf.fprintf c " by ";
      Printf.fprintf c "%s" (html_ref by1);
      let rec printf_html_byr by2 byr =
	match byr with
	| [] -> Printf.fprintf c " and %s" (html_ref by2)
	| by3::byrr ->
	    Printf.fprintf c ", %s" (html_ref by2);
	    printf_html_byr by3 byrr
      in
      printf_html_byr by2 byr

let rec reduce_goalstack gs =
  match gs with
  | PfStateSep(_,false)::gr -> reduce_goalstack gr
  | _ -> gs

let rec easygens m =
  let rl = ref [(Var(0),Some(m));(m,None)] in
  begin
    match m with
    | Prim(x,sp) -> List.iter (fun (sp,th) -> rl := (Prim(x,sp),th)::!rl) (easygens_sp sp)
    | Abbrev(x,sp) -> List.iter (fun (sp,th) -> rl := (Abbrev(x,sp),th)::!rl) (easygens_sp sp)
    | _ -> ()
  end;
  !rl
and easygens_sp ml =
  match ml with
  | [] -> [([],None)]
  | m::mr ->
      let y = easygens m in
      let z = easygens_sp mr in
      let rl = ref [] in
      List.iter
	(fun (n,o1) ->
	  List.iter
	    (fun (sp,o2) ->
	      match o2 with
	      | None -> rl := (n::sp,o1)::!rl
	      | Some(n2) ->
		  match o1 with
		  | None -> rl := (n::sp,o2)::!rl
		  | Some(n1) -> if n1 = n2 then rl := (n::sp,o1)::!rl)
	    z)
	y;
      !rl

let output_fakedists l r =
  let lr = tm_root l in
  let rr = tm_root r in
  Printf.printf "FAKEDIST\n%s\n%s\n1.0\n" lr rr;
  List.iter
    (fun (m,o) ->
      if not (o = None) then
	begin
	  if !verbose > 8 then Printf.printf "%s %s\n" (tm_root m) (tm_str m);
	  Printf.printf "FAKEDIST\n%s\n%s\n1.0\n" lr (tm_root m);
	  Printf.printf "FAKEDIST\n%s\n%s\n0.0\n" rr (tm_root m)
	end)
    (easygens r);
  List.iter
    (fun (m,o) ->
      if not (o = None) then
	begin
	  if !verbose > 8 then Printf.printf "%s %s\n" (tm_root m) (tm_str m);
	  Printf.printf "FAKEDIST\n%s\n%s\n1.0\n" rr (tm_root m);
	  Printf.printf "FAKEDIST\n%s\n%s\n0.0\n" lr (tm_root m)
	end)
    (easygens l)

let evaluate_eqpftacitem thmname thmhash n pctx label l r nll goalstack epfitem =
  match epfitem with
  | EqLink(a,obyl) ->
      let (nctx,hyps) = pctx in
      let newr = interp_aim_tm_r (ltree_to_atree a) fakefv nctx in
      ensureobvious pctx [NEq(r,newr)] false obyl;
      if !fakelearn then output_fakedists l newr;
      eqproving := Some(thmname,thmhash,n,pctx,label,l,newr,nll,goalstack);
      if !latex then
	begin
	  Printf.fprintf !latexc "\\\\\n";
	  Printf.fprintf !latexc " = & ";
	  ltree_to_latex_matharray 1 !latexc a;
	  match obyl with
	  | None -> ()
	  | Some(byl) ->
	      Printf.fprintf !latexc " & {\\mbox{ by }} ";
	      let fst = ref true in
	      List.iter (fun b -> if !fst then fst := false else Printf.fprintf !latexc ", "; Printf.fprintf !latexc "%s" (latex_ref b)) byl;
	end;
      if !html then
	begin
	  Printf.printf "</tr>\n<tr>";
	  Printf.printf "<td>=</td><td>";
	  ltree_to_html_math stdout (html_outer_ref fakefvh) a;
	  Printf.printf "</td>";
	  match obyl with
	  | None -> ()
	  | Some(byl) ->
	      Printf.printf "<td> by ";
	      let fst = ref true in
	      List.iter (fun b -> if !fst then fst := false else Printf.printf ", "; Printf.printf "%s" (html_ref b)) byl;
	end
  | EqDone ->
      let (nctx,hyps) = pctx in
(*      Printf.printf "After EqDone pusing eqn %s = %s onto hyps\n" (tm_str l) (tm_str r); *)
      if !latex then Printf.fprintf !latexc ".\n\\end{eqnarray*}\n";
      if !html then Printf.printf "</tr></table><br/>\n";
      eqproving := None;
      if !sexpr then Hashtbl.replace hyprefs label false;
      proving := Some(thmname,thmhash,n,(PfStateGoal((nctx,(label,[Eq(l,r)])::hyps),nll)::goalstack))

let rec structure_pfstate i g1 gs =
  match gs with
  | (PfStateGoal(g2a,g2b)::gr) ->
      (PfStateSep(i,true)::g1::structure_pfstate i (PfStateGoal(g2a,g2b)) gr)
  | gs ->
      (PfStateSep(i,true)::g1::PfStateSep(i,false)::gs)

let clause_of_refut r =
  match r with
  | Hyp(cl) -> (0,cl)
  | Kn(n,cl,_) -> (n,cl)
  | Def(n,cl,_,_) -> (n,cl)
  | Subst(n,cl,_,_,_) -> (n,cl)
  | Refl(n,cl,_) -> (n,cl)
  | Res(n,cl,_,_,_) -> (n,cl)
  | Para(n,cl,_,_,_,_,_) -> (n,cl)

let addnewsos r =
  let (n,cl) = clause_of_refut r in
  if cl = [] then
    raise (EmptyClause(r))
  else
    sos2 := r::!sos2

let rec delta_tms m =
  match m with
  | Prim(x,ml) ->
      let spl = delta_spines ml in
      let mll = ref [] in
      List.iter
	(fun (ml1,xl) ->
	  mll := (Prim(x,ml1),xl)::!mll)
	spl;
      !mll
  | Abbrev(x,ml) ->
      let spl = delta_spines ml in
      let mll = ref [] in
      List.iter
	(fun (ml1,xl) ->
	  mll := (Prim(x,ml1),xl)::!mll)
	spl;
      begin
	let arity = Hashtbl.find abbrevarity x in
	let mdef = Hashtbl.find abbrevdef x in
	let theta2 = Array.make arity (Skol("fake")) in
	if arity = List.length ml then
	  begin
	    for i = 0 to arity-1 do
	      theta2.(i) <- List.nth ml i
	    done;
	    let ndef = tm_subst theta2 mdef in
	    let nl = delta_tms ndef in
	    mll := (ndef,[x])::!mll;
	    List.iter
	      (fun (n,xl) -> mll := (n,rem_dups (x::xl))::!mll)
	      nl
	  end;
      end;
      !mll
  | _ -> []
and delta_spines ml =
  match ml with
  | [] -> []
  | m::mr ->
      let ml = delta_tms m in
      let mrl = delta_spines mr in
      let mll = ref [] in
      List.iter
	(fun (m1,xl) ->
	  mll := (m1::mr,xl)::!mll;
	  List.iter
	    (fun (mr1,yl) ->
	      mll := (m1::mr1,rem_dups (xl @ yl))::!mll)
	    mrl)
	ml;
      List.iter
	(fun (mr1,yl) ->
	  mll := (m::mr1,yl)::!mll)
	mrl;
      !mll

let delta_lits l =
  match l with
  | Eq(m,n) ->
      let ml = delta_tms m in
      let nl = delta_tms n in
      let ll = ref [] in
      List.iter
	(fun (m1,xl) ->
	  ll := (Eq(m1,n),xl)::!ll;
	  List.iter
	    (fun (n1,yl) ->
	      ll := (Eq(m1,n1),rem_dups (xl @ yl))::!ll)
	    nl)
	ml;
      List.iter
	(fun (n1,yl) ->
	  ll := (Eq(m,n1),yl)::!ll)
	nl;
      !ll
  | NEq(m,n) ->
      let ml = delta_tms m in
      let nl = delta_tms n in
      let ll = ref [] in
      List.iter
	(fun (m1,xl) ->
	  ll := (NEq(m1,n),xl)::!ll;
	  List.iter
	    (fun (n1,yl) ->
	      ll := (NEq(m1,n1),rem_dups (xl @ yl))::!ll)
	    nl)
	ml;
      List.iter
	(fun (n1,yl) ->
	  ll := (NEq(m,n1),yl)::!ll)
	nl;
      !ll

let rec delta_clauses cl =
  match cl with
  | [] -> []
  | l::cr ->
      let ll = delta_lits l in
      let crl = delta_clauses cr in
      let cll = ref [] in
      List.iter
	(fun (l1,xl) ->
	  cll := (l1::cr,xl)::!cll;
	  List.iter
	    (fun (cr1,yl) ->
	      cll := (l1::cr1,rem_dups (xl @ yl))::!cll)
	    crl)
	ll;
      List.iter
	(fun (cr1,yl) ->
	  cll := (l::cr1,yl)::!cll)
	crl;
      !cll

let delta_refuts r =
  let (n,cl) = clause_of_refut r in
  let dll = delta_clauses cl in
  List.map
    (fun (dl,xl) -> Def(n,dl,xl,r))
    dll

let ss n theta =
  let theta2 : tm array = Array.make n (Skol("fake")) in
  for i = 0 to n-1 do
    match theta.(i) with
    | None -> theta2.(i) <- Var(i)
    | Some(m) -> theta2.(i) <- m
  done;
  theta2

let hdist = ref false

let oracledist : (string * string,int) Hashtbl.t = Hashtbl.create 100

let dist lhs rhs =
  try
    match norm_clause_frees [Eq(lhs,rhs)] with (** normalizing frees here is the only choice that seems to work **)
    | ([Eq(lhs,rhs)],_,_) ->
       skol_reset();       
       let lhss = tm_str_1 lhs in
       let rhss = tm_str_1 rhs in
       if !verbose > 5 then (Printf.printf "asking about dist %s:%s\n" lhss rhss; flush stdout);
       let z = Hashtbl.find oracledist (lhss,rhss) in
       if !verbose > 5 then (Printf.printf "found %d\n" z; flush stdout);
       z
    | _ -> raise Not_found (** should notever happen **)
  with Not_found -> 50000

let rec onestep_pos vbd m lhs rhs =
  let rl = ref [] in
  begin
    try
      let theta : tm option array = Array.make vbd None in
      unif_dpairs theta [(m,lhs)];
      let theta2 = ss vbd theta in
      let z : tm = tm_subst theta2 rhs in
      rl := [(z,theta2)]
    with UnifFail -> ()
  end;
  match m with
  | Prim(x,sl) ->
      List.iter
	(fun (sp,theta) -> rl := (Prim(x,sp),theta)::!rl)
	(onestep_sp_pos vbd sl lhs rhs);
      !rl
  | Abbrev(x,sl) ->
      List.iter
	(fun (sp,theta) -> rl := (Abbrev(x,sp),theta)::!rl)
	(onestep_sp_pos vbd sl lhs rhs);
      !rl
  | _ -> !rl
and onestep_sp_pos vbd ml lhs rhs =
  match ml with
  | [] -> []
  | m::mr ->
      let rl = ref [] in
      List.iter (fun (n,theta) -> rl := (n::List.map (tm_subst theta) mr,theta)::!rl) (onestep_pos vbd m lhs rhs);
      List.iter (fun (nr,theta) -> rl := ((tm_subst theta m)::nr,theta)::!rl) (onestep_sp_pos vbd mr lhs rhs);
      !rl

let onestep vbd m =
  let rl = ref [] in
  List.iter
    (fun (nm,lhs,rhs) ->
      let lhs = push_tm_frees vbd lhs in
      let rhs = push_tm_frees vbd rhs in
      let vbd2 = clause_var_upperbd [Eq(lhs,rhs)] in
      List.iter (fun (z,theta) -> rl := (nm,z,theta) :: !rl) (onestep_pos vbd2 m lhs rhs);
      List.iter (fun (z,theta) -> rl := (nm,z,theta) :: !rl) (onestep_pos vbd2 m rhs lhs))
    !usableeqns;
  !rl

(** oracle never suggests intermediate forms **)
let suggest_interms lhs rhs = []

let oracle_advisor s2 s2in s2out =
  let currlhs = ref (Var(0)) in
  let currrhs = ref (Var(0)) in
  while true do
    let by = input_byte s2in in
    if by = 0 then (*** send the current lhs and rhs and then possibly suggest an intermediate form ***)
      begin
	skol_reset();
	let lhs = rec_tm s2in in
	let rhs = rec_tm s2in in
	currlhs := lhs;
	currrhs := rhs;
	let ml = suggest_interms lhs rhs in
	output_byte s2out (List.length ml);
	List.iter (send_tm s2out) ml;
	flush s2out
      end
    else if by = 1 then (*** get dist from rhs ***)
      begin
	let m = rec_tm s2in in
	let d = dist m !currrhs in
	let d = max 0 (min d 65535) in
	output_byte s2out 2;
	output_byte s2out (d asr 8);
	output_byte s2out (d mod 256);
	flush s2out
      end
    else if by = 2 then (*** get dist from lhs ***)
      begin
	let m = rec_tm s2in in
	let d = dist !currlhs m in
	let d = max 0 (min d 65535) in
	output_byte s2out 2;
	output_byte s2out (d asr 8);
	output_byte s2out (d mod 256);
	flush s2out
      end
  done

let max_avar m =
  let r = ref (-1) in
  for i = 0 to String.length m - 1 do
    match m.[i] with
    | 'x' -> r := max !r 0
    | 'y' -> r := max !r 1
    | 'z' -> r := max !r 2
    | 'w' -> r := max !r 3
    | 'u' -> r := max !r 4
    | _ -> ()
  done;
  !r

let max_evar m =
  let r = ref (-1) in
  for i = 0 to String.length m - 1 do
    match m.[i] with
    | 'X' -> r := max !r 0
    | 'Y' -> r := max !r 1
    | 'Z' -> r := max !r 2
    | 'W' -> r := max !r 3
    | 'U' -> r := max !r 4
    | _ -> ()
  done;
  !r

let perm p m =
  if p = [] then
    m
  else
    let b = Buffer.create 100 in
    for i = 0 to String.length m - 1 do
      try
	let y = List.assoc m.[i] p in
	Buffer.add_char b y
      with Not_found ->
	Buffer.add_char b m.[i]
    done;
    Buffer.contents b
      
let load_oracle_dist_file fn =
  let f = open_in fn in
  try
    while true do
      let lhs = input_line f in
      let rhs = input_line f in
      let d = int_of_float (1000.0 *. float_of_string (input_line f)) in
      let mav = max (max_avar lhs) (max_avar rhs) in
      let mev = max (max_evar lhs) (max_evar rhs) in
      let apl = if mav <= 2 then aperms3 else if mav = 3 then aperms4 else aperms5 in
      let epl = if mev <= 2 then eperms3 else if mev = 3 then eperms4 else eperms5 in
      List.iter
	(fun ep ->
	  let lhs2 = perm ep lhs in
	  let rhs2 = perm ep rhs in
	  Hashtbl.add oracledist (lhs2,rhs2) d;
	  Hashtbl.add oracledist (rhs2,lhs2) d;
	  List.iter
	    (fun ap ->
	      let lhs3 = perm ap lhs2 in
	      let rhs3 = perm ap rhs2 in
	      Hashtbl.add oracledist (lhs3,rhs3) d;
	      Hashtbl.add oracledist (rhs3,lhs3) d)
	    apl)
	epl
    done
  with _ -> ()

let main () =
  let i = Array.length Sys.argv in
  let j = ref 0 in
  while (!j < i - 2) do
    incr j;
    if Sys.argv.(!j) = "-sexpr" then
      sexpr := true
    else if Sys.argv.(!j) = "-evaluateconj" then
      evaluateconj := true
    else if Sys.argv.(!j) = "-countoptions" then
      countoptions := true
    else if Sys.argv.(!j) = "-ivy" then
      ivy := true
    else if Sys.argv.(!j) = "-latex" then
      latex := true
    else if Sys.argv.(!j) = "-fancylatex" then
      (latex := true; fancy := true)
    else if Sys.argv.(!j) = "-html" then
      html := true
    else if Sys.argv.(!j) = "-tptp" then
      tptpstyle := true
    else if Sys.argv.(!j) = "-publish" then
      publish := true
    else if Sys.argv.(!j) = "-prover9" then
      prover9style := true
    else if Sys.argv.(!j) = "-report" then
      report := true
    else if Sys.argv.(!j) = "-ensurecompletelysigned" then
      ensurecompletelysigned := true
    else if Sys.argv.(!j) = "-checkconjecturesforsubsumption" then
      check_conjectures_for_subsumption := true
    else if Sys.argv.(!j) = "-fakelearn" then
      fakelearn := true
    else if Sys.argv.(!j) = "-fakedist" then
      begin
	let f = open_in Sys.argv.(!j+1) in
	incr j;
	try
	  while true do
	    let l = input_line f in
	    if l = "FAKEDIST" then
	      let l1 = input_line f in
	      let l2 = input_line f in
	      let d = float_of_string (input_line f) in
	      Hashtbl.add fakedist (l1,l2) d
	    else if l = "FAKEDEPTH" then
	      let l1 = input_line f in
	      let d = int_of_string (input_line f) in
	      Hashtbl.add fakedepthh l1 d
	  done
	with End_of_file ->
	  close_in f
      end
    else if Sys.argv.(!j) = "-verb" then
      begin
	verbose := int_of_string Sys.argv.(!j+1);
	incr j
      end
    else if Sys.argv.(!j) = "-abslimit" then
      begin
	abstracttimelimit := Some(int_of_string Sys.argv.(!j+1));
	incr j
      end
    else if Sys.argv.(!j) = "-oracledistfile" then
      begin
	load_oracle_dist_file Sys.argv.(!j+1);
	incr j
      end
    else if Sys.argv.(!j) = "-advisorsocket" then
      begin
	advisorsocket := Some(int_of_string Sys.argv.(!j+1));
	incr j
      end
    else if Sys.argv.(!j) = "-summary" then
      begin
	summary := true
      end
    else
      Printf.printf "Ignoring %s\n" (Sys.argv.(!j));
  done;
  match !advisorsocket with
  | None -> Printf.printf "no socket given for advisor to listen on, eg, -advisorsocket 12159\n"
  | Some(port) ->
      let s1 = Unix.socket Unix.PF_INET Unix.SOCK_STREAM 0 in
      let ia = Unix.inet_addr_of_string "127.0.0.1" in
      Unix.bind s1 (Unix.ADDR_INET(ia, port));
      Unix.listen s1 5;
      while true do
	try
	  Printf.printf "Oracle waiting for connection\n"; flush stdout;
	  let (s2,a2) = Unix.accept s1 in
	  let s2in = Unix.in_channel_of_descr s2 in
	  let s2out = Unix.out_channel_of_descr s2 in
	  set_binary_mode_in s2in true;
	  set_binary_mode_out s2out true;
	  Printf.printf "Connected and advising\n"; flush stdout;
	  oracle_advisor s2 s2in s2out
	with _ -> ()
      done;;

try
  main();
  exit 0
with e ->
  Printf.printf "%s\n" (Printexc.to_string e);
  exit 1
